import {ActionContext} from "vuex";
import Keycloak from "keycloak-js";

const keyInitOptions = {
    url: 'https://auth.toking.de/',
    realm: 'toking',
    clientId: 'billibox',
    redirectUri: 'http://127.0.0.1:8080/',
    onLoad: 'login-required',
    enableLogging: true,
    scope: 'open-id'

}

const state = {
    keycloak: null,
    userProfile: null,
};

const getters = {
    isAuthenticated(state:any ) {
        return state.keycloak.authenticated
    },
    token: (state:any) => state.token,
    keycloak: (state:any) => state.keycloak,
    userProfile: (state:any) => state.userProfile

};

const mutations = {

    storeKeycloak(context:ActionContext<any, any>, payload:any) {
        console.log("mutations.storeKeycloak");
        state.keycloak = payload;
    },
    storeUserProfile(context:ActionContext<any, any>, payload:any) {
        state.userProfile = payload
    }
};

const actions = {

    storeKeycloak(context:ActionContext<any, any>, payload:any) {
        console.log("action.storeKeycloak");
        context.commit("storeKeycloak", payload);
    },
    getToken(context:any, payload:any) {
        console.log("actions.getToken")
        console.log("Authenticated", context.state.keycloak)

        context.state.keycloak.updateToken(70).then((refreshed) => {
            console.log("Refresehd Token", refreshed);
        }).catch((err)=> {
            console.log("Error", err);
        })
    },
    storeUserProfile(context:ActionContext<any, any>, payload:any) {
        console.log("STORE user Profile", payload);
        context.commit("storeUserProfile", payload)
    }

    };
const modules = {};

const authModule = {
    state,
    getters,
    mutations,
    actions,
    modules
}

export default authModule